<div
  class="m-comment minds-comment minds-block"
  [class.m-comment--error]="error"
>
  <div class="minds-avatar" [hovercard]="comment.ownerObj.guid">
    <a [routerLink]="['/', comment.ownerObj.username]">
      <img
        src="{{ minds.cdn_url }}icon/{{ comment.ownerObj.guid }}/small/{{
          comment.ownerObj.icontime
        }}"
        class="mdl-shadow--2dp"
      />
    </a>
  </div>
  <div class="minds-body">
    <div class="m-comment__bubble">
      <div class="m-commentBubble__username">
        <a [routerLink]="['/', comment.ownerObj.username]">
          <span title="{{ comment.ownerObj.name }}">{{
            comment.ownerObj.name
          }}</span>
          <m-channel--badges
            class="m-channel--badges-activity"
            [user]="comment.ownerObj"
            badges="[ 'admin', 'verified' ]"
          ></m-channel--badges>
        </a>
      </div>
      <p
        [hidden]="editing"
        class="m-commentBubble__message"
        [innerHtml]="comment.description || '' | tags"
      ></p>

      <p class="m-comment--error-label" *ngIf="error">
        <i class="material-icons">warning</i>
        <span>{{ error }}</span>
      </p>

      <m-translate
        [open]="translateToggle"
        [entity]="comment"
        (onTranslate)="translateToggle = false"
        (onTranslateError)="translateToggle = false"
        #translate
      ></m-translate>
    </div>

    <button
      class="m-comment__ribbonBtn"
      [ngClass]="{ 'm-comment__ribbonBtn--collapsed': !toggle.value }"
      (click)="toggle.value = !toggle.value"
    >
      <i class="material-icons">{{
        !toggle.value ? 'more_vert' : 'keyboard_arrow_left'
      }}</i>
    </button>

    <ul class="m-comment__ribbon" [hidden]="!toggle.value" #toggle>
      <li
        class="m-commentRibbon__item"
        *ngIf="
          comment.owner_guid == session.getLoggedInUser()?.guid ||
          session.isAdmin()
        "
        (click)="editing = !editing; toggle.value = false"
        title="Edit"
        i18n-title="@@M__ACTION__EDIT"
      >
        <i class="material-icons">edit</i>
      </li>
      <li
        class="m-commentRibbon__item"
        *ngIf="isTranslatable && !editing"
        (click)="translateToggle = true; toggle.value = false"
        title="Translate"
        i18n-title="@@M__ACTION__TRANSLATE"
      >
        <i class="material-icons">public</i>
      </li>
      <li
        class="m-commentRibbon__item"
        *ngIf="
          comment.owner_guid == session.getLoggedInUser()?.guid ||
          session.isAdmin() ||
          parent.owner_guid == session.getLoggedInUser()?.guid ||
          canEdit
        "
        (click)="delete(); toggle.value = false"
        title="Delete"
        i18n-title="@@M__ACTION__DELETE"
      >
        <i class="material-icons">delete</i>
      </li>
      <li
        class="m-commentRibbon__item"
        *ngIf="
          !editing && comment.owner_guid != session.getLoggedInUser()?.guid
        "
        (click)="showReport()"
        title="Report"
        i18n-title="verb|@@M__ACTION__REPORT"
      >
        <i class="material-icons">flag</i>
      </li>
    </ul>

    <div class="m-comment__attachment">
      <div
        class="mdl-card m-comment-attachment"
        [hidden]="editing"
        *ngIf="
          (comment.perma_url && comment.title) ||
          comment.custom_type == 'batch' ||
          comment.custom_type == 'video'
        "
      >
        <!-- Rich content -->
        <div
          class="m-rich-embed m-border cf"
          *ngIf="comment.perma_url && comment.title"
          [ngClass]="{
            'm-mature-content': attachment.shouldBeBlurred(comment),
            'm-mature-content-shown': attachment.isForcefullyShown(comment)
          }"
        >
          <div
            class="m-mature-overlay"
            (click)="comment.mature_visibility = !comment.mature_visibility"
          >
            <span class="m-mature-overlay-note m-mature-overlay-note-smaller">
              <i
                class="material-icons"
                title="Mature content"
                i18n-title="@@M__COMMON__MATURE_CONTENT"
                >explicit</i
              >
              <span i18n="@@M__COMMON__CONFIRM_18"
                >Click to confirm your are 18+</span
              >
            </span>
          </div>

          <minds-rich-embed
            [src]="comment"
            [maxheight]="240"
            [cropImage]="true"
          ></minds-rich-embed>
        </div>

        <!-- Custom type ::  video -->
        <div
          class="item item-image item-image-video"
          [ngClass]="{
            'm-mature-content': attachment.shouldBeBlurred(comment),
            'm-mature-content-shown': attachment.isForcefullyShown(comment)
          }"
          *ngIf="comment.custom_type == 'video'"
        >
          <div
            class="m-mature-overlay"
            (click)="comment.mature_visibility = !comment.mature_visibility"
          >
            <span class="m-mature-overlay-note">
              <i
                class="material-icons"
                title="Mature content"
                i18n-title="@@M__COMMON__MATURE_CONTENT"
                >explicit</i
              >
              <span i18n="@@M__COMMON__CONFIRM_18"
                >Click to confirm your are 18+</span
              >
            </span>
          </div>

          <m-video
            width="100%"
            height="300px"
            controls="true"
            muted="false"
            [poster]="comment.custom_data.thumbnail_src"
            [autoplay]="false"
            [src]="[
              {
                res: '360',
                uri: 'api/v1/media/' + comment.custom_data.guid + '/play',
                type: 'video/mp4'
              }
            ]"
            [guid]="comment.custom_data.guid"
            [playCount]="comment['play:count']"
            [torrent]="[
              { res: '360', key: comment.custom_data.guid + '/360.mp4' }
            ]"
          >
          </m-video>
        </div>

        <!-- Custom type:: batch -->
        <div
          class="item item-image allow-select"
          [ngClass]="{
            'm-mature-content': attachment.shouldBeBlurred(comment),
            'm-mature-content-shown': attachment.isForcefullyShown(comment)
          }"
          *ngIf="!editing && comment.custom_type == 'batch'"
        >
          <div
            class="m-mature-overlay"
            (click)="comment.mature_visibility = !comment.mature_visibility"
          >
            <span class="m-mature-overlay-note">
              <i
                class="material-icons"
                title="Mature content"
                i18n-title="@@M__COMMON__MATURE_CONTENT"
                >explicit</i
              >
              <span i18n="@@M__COMMON__CONFIRM_18"
                >Click to confirm your are 18+</span
              >
            </span>
          </div>
          <a
            target="_blank"
            [routerLink]="['/media', comment.attachment_guid]"
            *ngIf="comment.attachment_guid"
          >
            <img
              [src]="comment.custom_data[0].src"
              class="mdl-shadow--2dp"
              (error)="
                comment.custom_data[0].src =
                  minds.cdn_assets_url + 'assets/logos/medium.png'
              "
            />
          </a>

          <img
            *ngIf="!comment.attachment_guid"
            [src]="comment.custom_data[0].src"
            (error)="
              comment.custom_data[0].src =
                minds.cdn_assets_url + 'assets/logos/medium.png'
            "
          />
        </div>
      </div>

      <!-- Edit mode -->

      <ng-container *ngIf="editing">
        <div class="minds-editable-container">
          <!-- Please not the intentional single way binding for ngModel, we want to be able to cancel our changes -->
          <textarea
            class="mdl-card__supporting-text message"
            name="description"
            [ngModel]="comment.description"
            #edit
            [autoGrow]
            (keydown.enter)="applyAndSave(edit, $event)"
            (keydown.esc)="cancel(edit, $event)"
            (keyup)="getPostPreview(edit)"
            [disabled]="inProgress"
          ></textarea>
          <span
            class="minds-comment-span"
            *ngIf="canPost"
            i18n="@@MINDS__CARDS__COMMENT__PRESS_ESC_TO_CANCEL"
            >Press ESC to cancel</span
          >
          <div
            class="minds-comment-span mdl-color-text--red-500"
            *ngIf="!canPost && triedToPost"
          >
            <ng-container i18n="@@M__COMMON__WAIT_UPLOAD"
              >Please wait until the upload is complete.</ng-container
            >
          </div>

          <div class="mdl-card__actions">
            <!-- Attachements -->
            <div
              class="attachment-button"
              [ngClass]="{ 'mdl-color-text--amber-500': attachment.hasFile() }"
            >
              <i class="material-icons">attachment</i>
              <input
                type="file"
                id="file"
                #fileInput
                name="attachment"
                (change)="uploadAttachment(fileInput)"
              />
            </div>

            <a
              class="m-mature-button"
              [ngClass]="{ 'mdl-color-text--red-500': attachment.isMature() }"
              (click)="attachment.toggleMature()"
              title="Mature content"
              i18n-title="@@M__COMMON__MATURE_CONTENT"
            >
              <i class="material-icons">explicit</i>
            </a>

            <a
              class="m-post-button"
              (click)="applyAndSave(edit, $event)"
              [ngClass]="{ 'm-button-disabled': !saveEnabled() }"
            >
              <i class="material-icons">send</i>
            </a>
          </div>
        </div>

        <div class="m-editable-attachment-container">
          <!-- Attachment preview -->
          <div
            class="post-preview"
            *ngIf="attachment.hasFile() || attachment.getUploadProgress() > 0"
            (click)="removeAttachment(fileInput)"
          >
            <div
              class="mdl-progress mdl-js-progress"
              [mdlUpload]
              [progress]="attachment.getUploadProgress()"
              [hidden]="attachment.getUploadProgress() == 0"
              [ngClass]="{ complete: attachment.getUploadProgress() == 100 }"
            ></div>
            <div
              *ngIf="attachment.getMime() == 'video'"
              class="attachment-preview video-placeholder mdl-color--blue-grey-600"
            >
              <i class="material-icons">videocam</i>
            </div>
            <img
              *ngIf="attachment.getMime() != 'video'"
              [src]="attachment.getPreview()"
              class="attachment-preview mdl-shadow--2dp"
            />
            <div class="attachment-preview-delete">
              <i class="material-icons">delete</i>
            </div>
          </div>

          <!-- Rich embed preview -->
          <div class="post-preview" *ngIf="attachment.isRich()">
            <div
              class="mdl-spinner mdl-js-spinner is-active"
              [mdl]
              [hidden]="attachment.getMeta().title"
            ></div>
            <div
              class="m-rich-embed mdl-shadow--2dp cf"
              *ngIf="attachment.getMeta().title"
            >
              <minds-rich-embed
                [preview]="attachment.getMeta()"
                [cropImage]="true"
              ></minds-rich-embed>
            </div>
          </div>
        </div>
      </ng-container>
    </div>

    <div class="m-comment__toolbar" *ngIf="comment?.guid">
      <div class="m-commentToolbar__buttons" [hidden]="editing">
        <minds-button-thumbs-up
          [object]="comment"
          [class.has-count]="comment['thumbs:up:count'] > 0"
        ></minds-button-thumbs-up>
        <minds-button-thumbs-down [object]="comment"></minds-button-thumbs-down>
        <span
          class="m-clickable"
          [class.selected]="comment.replies_count > 0"
          (click)="toggleReplies()"
          *ngIf="comment.can_reply"
        >
          <i class="material-icons">reply</i>
          <span *ngIf="comment.replies_count > 0"
            >{{ comment.replies_count }} Replies</span
          >
          <span *ngIf="comment.replies_count <= 0">Reply</span>
        </span>
      </div>

      <span
        [title]="comment.time_created * 1000 | date: 'medium'"
        class="m-commentToolbar__timestamp"
        *ngIf="commentAge$ | async as commentAge"
        >{{ commentAge | friendlydatediff }}</span
      >
      <span
        *ngIf="comment.edited"
        class="m-edited-text"
        i18n="@@M__COMMON__EDITED"
        >edited</span
      >
    </div>

    <minds-comments
      [object]="comment"
      [parentGuid]="comment._guid"
      [canEdit]="canEdit"
      *ngIf="showReplies && comment.can_reply"
    >
    </minds-comments>
  </div>
</div>
